package com.hzya.frame.plugin.incomeInvoiceData.service.impl;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.mdm.mdmModuleSource.entity.MdmModuleSourceEntity;
import com.hzya.frame.plugin.incomeInvoiceData.dao.IIncomeInvoiceDao;
import com.hzya.frame.plugin.incomeInvoiceData.entity.IncomeInvoiceEntity;
import com.hzya.frame.plugin.incomeInvoiceData.service.IIncomeInvoiceService;
import com.hzya.frame.seeyon.util.YzfSignUtil;
import com.hzya.frame.sysnew.application.entity.SysExtensionApiEntity;
import com.hzya.frame.sysnew.comparison.controlsLog.dao.impl.ControlsLogDaoImpl;
import com.hzya.frame.sysnew.comparison.controlsLog.entity.ControlsLogEntity;
import com.hzya.frame.sysnew.comparison.dao.IComparisonDao;
import com.hzya.frame.sysnew.comparison.entity.ComparisonEntity;
import com.hzya.frame.uuid.UUIDLong;
import com.hzya.frame.uuid.UUIDUtils;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.apache.http.HttpEntity;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.ssl.NoopHostnameVerifier;
import org.apache.http.conn.ssl.TrustAllStrategy;
import org.apache.http.entity.ByteArrayEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.ssl.SSLContextBuilder;
import org.apache.http.util.EntityUtils;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;
import com.hzya.frame.basedao.service.impl.BaseService;

import javax.net.ssl.SSLContext;
import java.io.IOException;
import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author makejava
 * @since 2024-06-21 13:52:35
 */
public class IncomeInvoiceServiceImpl extends BaseService<IncomeInvoiceEntity, String> implements IIncomeInvoiceService {

    private IIncomeInvoiceDao incomeInvoiceDao;
    @Autowired
    private ControlsLogDaoImpl controlsLogDaoimpl;
    @Autowired
    private IComparisonDao comparisonDao;
    @Autowired
    public void setIncomeInvoiceDao(IIncomeInvoiceDao dao) {
        this.incomeInvoiceDao = dao;
        this.dao = dao;
    }
    String cbUrl = "http://oapi.nanofintax.com/api/collect/uploadFinancialReport?accessToken=";
    String dataUrl = "http://oapi.nanofintax.com/api/invoice_receive/fp/v1/query?accessToken=";
    String tokenUrl = "http://oapi.nanofintax.com/api/getToken";
    String accessKey = "6X3B526P5HqE6ums";
    String accessSecret = "34e5fc32ac894a2ba2ade8c3852c7a0a";
    String taxNo = "91330110MAC5FPUY2U";
    Integer size = 50;

    /**
     * @Author lvleigang
     * @Description  全量发票数据
     * @Date 4:28 下午 2025/4/16
     * @param requestJson
     * @return com.hzya.frame.web.entity.JsonResultEntity
     **/
    @Override
    public JsonResultEntity getIncomeInvoiceData(JSONObject requestJson) {
        //1、调用token
        String access_token = getToken();
        if (access_token == null) {
            return BaseResult.getFailureMessageEntity("token获取失败");
        }
        Date date = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String times = sdf.format(date);
        //2、调用接口获取数据
        Integer queryCursor = 1;
        JSONArray datalist = new JSONArray();
        sendBusinessData(datalist, access_token, queryCursor,times);

        if(datalist != null && datalist.size() > 0){
            for (int i = 0; i < datalist.size(); i++) {
                 JSONObject saveData = new JSONObject();
                //3、对照数据
                JSONObject jsonObject = datalist.getJSONObject(i);
                JSONObject content = jsonObject.getJSONObject("content");

                //发票号码
                String fphm = jsonObject.getString("fphm");
                if(fphm == null || "".equals(fphm) ){
                    continue;
                }
                saveData.put("fphm",fphm);
                //判断是否有这个数据
                List<JSONObject> checkData = incomeInvoiceDao.queryData(saveData);
                if(checkData != null && checkData.size() > 0){
                    continue;
                }
                saveData.put("id", String.valueOf(UUIDLong.longUUID()));
                saveData.put("create_user_id", "c796fd9ba4c9f5ff3cc2fa41a040e443");
                saveData.put("modify_user_id", "c796fd9ba4c9f5ff3cc2fa41a040e443");
                saveData.put("org_id", "0");
                saveData.put("create_time", new Date());
                saveData.put("modify_time", new Date());
                saveData.put("sts", "Y");
                saveData.put("data_status", "Y");//新增状态
                saveData.put("add_status", "0");//新增状态
                saveData.put("update_status", "1");//修改状态
                saveData.put("delete_status", "1");//删除状态
                ComparisonEntity comparisonEntityRule = new ComparisonEntity();
                comparisonEntityRule.setRulePrefix("FP");
                comparisonEntityRule.setRuleMiddle("%Y-%m-%d");
                comparisonEntityRule.setRuleSuffix(5);
                comparisonEntityRule.setDbName("mdm_fp");
                ComparisonEntity comparisonEntityRuleGz = comparisonDao.queryComparisonRule(comparisonEntityRule);
                saveData.put("document_rule", comparisonEntityRuleGz.getDocumentRule());//单据规则
                saveData.put("document_rule_num", comparisonEntityRuleGz.getDocumentRuleNum());//单据规则流水号

                saveData.put("fphm",fphm);
                saveData.put("fpdm",content.getString("fpdm"));
                saveData.put("kprq",jsonObject.getString("kprq"));
                saveData.put("xfsh",content.getString("xfsh"));
                saveData.put("xfmc",content.getString("xfmc"));
                saveData.put("gfsh",content.getString("gfsh"));
                saveData.put("gfmc",content.getString("gfmc"));
                saveData.put("hjje",content.getString("hjje"));
                saveData.put("hjse",content.getString("hjse"));
                saveData.put("jshj",content.getString("jshj"));
                saveData.put("jym",content.getString("jym"));
                saveData.put("xfdzdh",content.getString("xfdzdh"));
                saveData.put("xfyhzh",content.getString("xfyhzh"));
                saveData.put("gfdzdh",content.getString("gfdzdh"));
                saveData.put("gfyhzh",content.getString("gfyhzh"));
                saveData.put("mmq",content.getString("mmq"));
                saveData.put("bz",content.getString("bz"));
                saveData.put("jqbh",content.getString("jqbh"));
                saveData.put("jdhm",content.getString("jdhm"));
                saveData.put("kpr",content.getString("kpr"));
                saveData.put("skr",content.getString("skr"));
                saveData.put("fhr",content.getString("fhr"));
                saveData.put("url",content.getString("url"));
                saveData.put("ofdurl",content.getString("ofdUrl"));
                saveData.put("xmlurl",content.getString("xmlUrl"));
                saveData.put("htbh",content.getString("contraceNumber"));

                JSONArray detaildata = content.getJSONArray("items");
                if(detaildata != null && detaildata.size() > 0){
                    for (int i1 = 0; i1 < detaildata.size(); i1++) {
                        JSONObject saveDetailData = new JSONObject();

                        saveDetailData.put("id", String.valueOf(UUIDLong.longUUID()));
                        saveDetailData.put("formmain_id", saveData.getString("id"));
                        saveDetailData.put("data_status", "Y");//新增状态

                        saveDetailData.put("create_user_id", "c796fd9ba4c9f5ff3cc2fa41a040e443");
                        saveDetailData.put("modify_user_id", "c796fd9ba4c9f5ff3cc2fa41a040e443");
                        saveDetailData.put("org_id", "0");
                        saveDetailData.put("create_time", new Date());
                        saveDetailData.put("modify_time", new Date());
                        saveDetailData.put("sts", "Y");
                        saveDetailData.put("xh", detaildata.getJSONObject(i1).getString("xh"));
                        saveDetailData.put("ssflbm", detaildata.getJSONObject(i1).getString("ssflbm"));
                        saveDetailData.put("xmmc", detaildata.getJSONObject(i1).getString("xmmc"));
                        saveDetailData.put("ggxh", detaildata.getJSONObject(i1).getString("ggxh"));
                        saveDetailData.put("dw", detaildata.getJSONObject(i1).getString("dw"));
                        saveDetailData.put("sl", detaildata.getJSONObject(i1).getString("sl"));
                        saveDetailData.put("dj", detaildata.getJSONObject(i1).getString("dj"));
                        saveDetailData.put("je", detaildata.getJSONObject(i1).getString("je"));
                        saveDetailData.put("slv", detaildata.getJSONObject(i1).getString("slv"));
                        saveDetailData.put("se", detaildata.getJSONObject(i1).getString("se"));

                        incomeInvoiceDao.saveDetailData(saveDetailData);
                    }
                }
                incomeInvoiceDao.saveData(saveData);

                //5、保存写入日志
                ControlsLogEntity controlsLogEntity=new ControlsLogEntity();
                controlsLogEntity.setId(UUIDUtils.getUUID());
                controlsLogEntity.setFormmainId(saveData.getString("id"));
                controlsLogEntity.setSourceName("数智中台");
                controlsLogEntity.setCode("800004");
                controlsLogEntity.setSourceData(jsonObject.toString());
                controlsLogEntity.setOptionType("接口新增");
                controlsLogEntity.setOptionName("数智中台");
                controlsLogEntity.setDbName("mdm_fp_option_log");
                controlsLogEntity.setDataType("1");
                controlsLogEntity.setCreate_user_id("c796fd9ba4c9f5ff3cc2fa41a040e443");
                controlsLogEntity.setModify_user_id("c796fd9ba4c9f5ff3cc2fa41a040e443");
                controlsLogEntity.setOrg_id("0");
                controlsLogEntity.setRemark("插件新增");
                controlsLogDaoimpl.saveControlsLog(saveData.getString("id"), "数智中台", "800004", jsonObject.toJSONString(), "接口新增", "数智中台", "mdm_fp_option_log", "1");
            }
        }
        return BaseResult.getSuccessMessageEntity("处理成功");
    }


    /**
     * @Author lvleigang
     * @Description  获取业务数据
     * @Date 4:31 下午 2025/4/9
     * @param datalist
     * @param access_token
     * @param queryCursor
     * @param dataTime
     * @return void
     **/
    private void sendBusinessData(JSONArray datalist, String access_token, Integer queryCursor, String dataTime) {
        String url = dataUrl+access_token;
        JSONObject dayabody = new JSONObject();
        dayabody.put("accessKey",accessKey);
        long timestamp = System.currentTimeMillis();
        dayabody.put("timestamp",timestamp);
        JSONObject queryParams = new JSONObject();
        queryParams.put("page",queryCursor);
        queryParams.put("size",size);
        //queryParams.put("kprqq",dataTime);
        //queryParams.put("kprqz",dataTime);
        queryParams.put("taxNo",taxNo);
        dayabody.put("queryParams",queryParams);
        Map<String, Object> parametersMap = new HashMap<>();
        parametersMap.put("accessKey",accessKey);
        parametersMap.put("timestamp",timestamp);
        String a = YzfSignUtil.signRequest(parametersMap,accessSecret);
        dayabody.put("sign",a);
        Map<String, String> headers = new HashMap<>();
        headers.put("Content-Type", "application/json; charset=utf-8");
        String returndata = sendPost(url, headers, dayabody.toJSONString());

		if (returndata != null && JSONObject.isValidObject(returndata)) {
			JSONObject dataJson = JSONObject.parseObject(returndata);
			if(dataJson != null && dataJson.getString("code") != null && "0".equals( dataJson.getString("code"))){
                JSONObject data = dataJson.getJSONObject("result");
			    if(data != null  ){
                    JSONArray businessList = data.getJSONArray("data");
                    if(data.getInteger("total") > queryCursor*size){
                        queryCursor = queryCursor+1;
                        sendBusinessData(datalist, access_token, queryCursor, dataTime);
                    }
                    if(businessList != null && businessList.size() > 0){
                        datalist.addAll(businessList);
                    }
				}
			}
		}
    }

    private String getOAToken(String name) {
        String url = "http://60.204.152.210/seeyon/rest/token";
        Map<String, String> headers = null;
        String bodys = "{\"password\":\"a5ce21b8-91db-4cec-b3e3-3e44719655fd\",\"userName\":\"hzyaRest\",\"loginName\":\""+name+"\"}";
        String tokenData = sendPost(url, headers, bodys);
        String access_token = null;
        if (tokenData != null && JSONObject.isValidObject(tokenData)) {
            JSONObject tokendataJson = JSONObject.parseObject(tokenData);
            if (tokendataJson != null && tokendataJson.getString("id") != null) {
                access_token = tokendataJson.getString("id");
            }
        }
        return access_token;
    }
    /**
     * @Author lvleigang
     * @Description  获取token
     * @Date 4:18 下午 2025/4/9
     * @param
     * @return java.lang.String
     **/
    private String getToken() {
        String url = tokenUrl;
        JSONObject tokenJson = new JSONObject();
        tokenJson.put("accessKey",accessKey);
        tokenJson.put("accessSecret",accessSecret);
        String bodys = tokenJson.toJSONString();
        StringBuilder body = new StringBuilder();
        SSLContext sslContext = null;
        try {
            sslContext = new SSLContextBuilder()
                    .loadTrustMaterial(null, TrustAllStrategy.INSTANCE)
                    .build();
        } catch (Exception e) {
            return null;
        }
        CloseableHttpClient closeableHttpClient = HttpClients.custom()
                .setSSLContext(sslContext)
                .setSSLHostnameVerifier(NoopHostnameVerifier.INSTANCE)
                .build();

        HttpPost post = new HttpPost(url);
        CloseableHttpResponse response = null;
        RequestConfig requestConfig = RequestConfig.custom().setConnectTimeout(6000).build();
        post.setConfig(requestConfig);//设置请求参数【超时时间】
        post.setHeader("Content-Type", "application/json; charset=utf-8");
        try {
            if (bodys != null && !"".equals(bodys)) {
                ByteArrayEntity entity = new ByteArrayEntity(bodys.getBytes("UTF-8"));
                entity.setContentType("application/json");
                post.setEntity(entity);
            }
            response = closeableHttpClient.execute(post);

            HttpEntity entity = response.getEntity();
            body.append(EntityUtils.toString(entity, "UTF-8"));
        } catch (Exception e) {
            body.append(e.getMessage());
        } finally {
            try {
                // 关闭响应对象
                if (response != null) {
                    response.close();
                }
                // 关闭响应对象
                if (closeableHttpClient != null) {
                    closeableHttpClient.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }

        }
        logger.info("token返回结果{}",body);
        JSONObject bodyJson = JSONObject.parseObject(body.toString());
        if(bodyJson.getString("code") == null || !"0".equals(bodyJson.getString("code"))){
            return null;
        }
        JSONObject resultJson = bodyJson.getJSONObject("result");
        if(resultJson == null){
            return null;
        }
        if(resultJson.getString("accessToken") != null && !"".equals(resultJson.getString("accessToken"))){
            return resultJson.getString("accessToken");
        }
        return null;
    }

    private String sendPost(String url, Map<String, String> headers, String bodys) {
        logger.info("url："+url+"。bodys："+bodys);

        SSLContext sslContext = null;
        try {
            sslContext = new SSLContextBuilder()
                    .loadTrustMaterial(null, TrustAllStrategy.INSTANCE)
                    .build();
        } catch (Exception e) {

        }
        CloseableHttpClient closeableHttpClient = HttpClients.custom()
                .setSSLContext(sslContext)
                .setSSLHostnameVerifier(NoopHostnameVerifier.INSTANCE)
                .build();
        HttpPost post = new HttpPost(url);
        CloseableHttpResponse response = null;
        RequestConfig requestConfig = RequestConfig.custom().setConnectTimeout(60000).build();
        post.setConfig(requestConfig);//设置请求参数【超时时间】
        if (headers != null && headers.size() > 0) {
            for (String key : headers.keySet()) {
                post.setHeader(key, headers.get(key));
            }
        }
        StringBuilder body = new StringBuilder();
        try {
            if (bodys != null && !"".equals(bodys)) {
                ByteArrayEntity entity = new ByteArrayEntity(bodys.getBytes("UTF-8"));
                entity.setContentType("application/json");
                post.setEntity(entity);
            }
            response = closeableHttpClient.execute(post);
            HttpEntity entity = response.getEntity();
            body.append(EntityUtils.toString(entity, "UTF-8"));
            logger.info("返回结果：" + body);
        } catch (Exception e) {
            logger.error("请求错误：" + e.getMessage());
            body = new StringBuilder();
        } finally {
            try {
                // 关闭响应对象
                if (response != null) {
                    response.close();
                }
                // 关闭响应对象
                if (closeableHttpClient != null) {
                    closeableHttpClient.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }

        }
        logger.info("url："+url+"。bodys："+bodys+"。body"+body);

        return body.toString();
    }
    private String sendGet(String url, Map<String, String> headers) {
        SSLContext sslContext = null;
        try {
            sslContext = new SSLContextBuilder()
                    .loadTrustMaterial(null, TrustAllStrategy.INSTANCE)
                    .build();
        } catch (Exception e) {

        }
        CloseableHttpClient closeableHttpClient = HttpClients.custom()
                .setSSLContext(sslContext)
                .setSSLHostnameVerifier(NoopHostnameVerifier.INSTANCE)
                .build();
        // HttpClient
        HttpGet get = new HttpGet(url);
        CloseableHttpResponse response = null;

        RequestConfig requestConfig = RequestConfig.custom().setConnectTimeout(60000).build();
        get.setConfig(requestConfig);//设置请求参数【超时时间】
        if (headers != null && headers.size() > 0) {
            for (String key : headers.keySet()) {
                get.setHeader(key, headers.get(key));
            }
        }
        StringBuilder body = new StringBuilder();

        try {
            response = closeableHttpClient.execute(get);
            HttpEntity entity = response.getEntity();
            body.append(EntityUtils.toString(entity,"UTF-8"));
            logger.info("返回结果：" + body);
        } catch (Exception e) {
            logger.error("请求错误：" + e.getMessage());
            body.append(e.getMessage());
        } finally {
            try {
                // 关闭响应对象
                if (response != null) {
                    response.close();
                }
                // 关闭响应对象
                if (closeableHttpClient != null) {
                    closeableHttpClient.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return body.toString();
    }


    /**
     * seeyon流程事件监听前置方法，绑定数据源
     * @param entity
     * @return
     * @throws Exception
     */
    @Override
    public SysExtensionApiEntity setData(SysExtensionApiEntity entity) throws Exception {
        try {
            JSONObject sendBody = new JSONObject();
            String bodys = entity.getBodys();
            Map<String, String> headers = entity.getHeaders();
            JSONObject jsonObject = JSONObject.parseObject(bodys);
            String loginName = "hzya";
            String dataXml = getXml(jsonObject);
            //处理xml数据
            String oaToken = getOAToken(loginName);
            headers.put("token",oaToken);
            sendBody.put("token",oaToken);
            sendBody.put("loginName",loginName);
            sendBody.put("dataXml",dataXml);
            entity.setBodys(sendBody.toJSONString());
            //修改明细表
            if(jsonObject.getString("htbh") != null){
                IncomeInvoiceEntity incomeInvoiceEntity = new IncomeInvoiceEntity();
                incomeInvoiceEntity.setDataSourceCode("master");//todo
                //incomeInvoiceEntity.setDataSourceCode("HT-OA");//todo
                incomeInvoiceEntity.setField0003(jsonObject.getString("htbh"));//合同号
                incomeInvoiceEntity.setField0127(jsonObject.getString("fpdm"));//发票代码
                incomeInvoiceEntity.setField0128(jsonObject.getString("fphm"));//发票号码
                incomeInvoiceEntity.setField0129(jsonObject.getString("jshj"));//发票总额
                incomeInvoiceEntity.setField0130(jsonObject.getString("fpwj"));//发票文件 todo
                List<IncomeInvoiceEntity> list = incomeInvoiceDao.queryOaZb(incomeInvoiceEntity);
                if(list != null && list.size() == 1){
                    incomeInvoiceEntity.setFormmainId(list.get(0).getDataId());
                }
                List<IncomeInvoiceEntity> mxlist = incomeInvoiceDao.queryOaMx(incomeInvoiceEntity);
                if(mxlist != null && mxlist.size() == 1){
                    incomeInvoiceEntity.setDataId(mxlist.get(0).getDataId());
                    incomeInvoiceDao.updateMx(incomeInvoiceEntity);
                }
                if(mxlist == null || mxlist.size() == 0){
                    incomeInvoiceEntity.setDataId(1);
                    incomeInvoiceDao.saveMx(incomeInvoiceEntity);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return entity;
    }



    private String getXml(JSONObject jsonObject) {
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append("<forms  version=\"2.1\">");
        stringBuffer.append("<formExport>");
        stringBuffer.append("<summary  id=\"142379148423086857\" name=\"formmain_0705\"/>");
        stringBuffer.append("<definitions>");
        stringBuffer.append("<column  id=\"field0001\" type=\"0\" name=\"发票代码\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0002\" type=\"0\" name=\"发票号码\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0003\" type=\"3\" name=\"开票日期\" isNullable=\"false\" length=\"255\"/>");
        stringBuffer.append("<column  id=\"field0004\" type=\"0\" name=\"销方税号\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0005\" type=\"0\" name=\"销方名称\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0006\" type=\"0\" name=\"购方税号\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0007\" type=\"0\" name=\"购方名称\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0008\" type=\"4\" name=\"合计金额\" isNullable=\"false\" length=\"20\"/>");
        stringBuffer.append("<column  id=\"field0009\" type=\"4\" name=\"合计税额\" isNullable=\"false\" length=\"20\"/>");
        stringBuffer.append("<column  id=\"field0010\" type=\"4\" name=\"价税合计\" isNullable=\"false\" length=\"20\"/>");
        stringBuffer.append("<column  id=\"field0011\" type=\"0\" name=\"校验码\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0012\" type=\"0\" name=\"销售方地址电话\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0013\" type=\"0\" name=\"销售方开户行及账号\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0014\" type=\"0\" name=\"购买方地址电话\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0015\" type=\"0\" name=\"购买方开户行及账号\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0017\" type=\"0\" name=\"备注\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0018\" type=\"0\" name=\"机器编号\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0019\" type=\"0\" name=\"机打号码\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0020\" type=\"0\" name=\"开票人\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0021\" type=\"0\" name=\"收款人\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0022\" type=\"0\" name=\"复核人\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0033\" type=\"0\" name=\"合同编号\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0034\" type=\"0\" name=\"发票文件\" isNullable=\"false\" length=\"20\"/>");
        stringBuffer.append("</definitions>");
        stringBuffer.append("<values>");

        stringBuffer.append("<column  name=\"发票代码\">").append("<value>");
        stringBuffer.append(jsonObject.getString("fpdm") != null?"<![CDATA["+jsonObject.getString("fpdm")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"发票号码\">").append("<value>");
        stringBuffer.append(jsonObject.getString("fphm") != null?"<![CDATA["+jsonObject.getString("fphm")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"开票日期\">").append("<value>");
        stringBuffer.append(jsonObject.getString("kprq") != null?"<![CDATA["+jsonObject.getString("kprq")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"销方税号\">").append("<value>");
        stringBuffer.append(jsonObject.getString("xfsh") != null?"<![CDATA["+jsonObject.getString("xfsh")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"销方名称\">").append("<value>");
        stringBuffer.append(jsonObject.getString("xfmc") != null?"<![CDATA["+jsonObject.getString("xfmc")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"购方税号\">").append("<value>");
        stringBuffer.append(jsonObject.getString("gfsh") != null?"<![CDATA["+jsonObject.getString("gfsh")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"购方名称\">").append("<value>");
        stringBuffer.append(jsonObject.getString("gfmc") != null?"<![CDATA["+jsonObject.getString("gfmc")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"合计金额\">").append("<value>");
        stringBuffer.append(jsonObject.getString("hjje") != null?"<![CDATA["+jsonObject.getString("hjje")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"合计税额\">").append("<value>");
        stringBuffer.append(jsonObject.getString("hjse") != null?"<![CDATA["+jsonObject.getString("hjse")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"价税合计\">").append("<value>");
        stringBuffer.append(jsonObject.getString("jshj") != null?"<![CDATA["+jsonObject.getString("jshj")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"校验码\">").append("<value>");
        stringBuffer.append(jsonObject.getString("jym") != null?"<![CDATA["+jsonObject.getString("jym")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"销售方地址电话\">").append("<value>");
        stringBuffer.append(jsonObject.getString("xfdzdh") != null?"<![CDATA["+jsonObject.getString("xfdzdh")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"销售方开户行及账号\">").append("<value>");
        stringBuffer.append(jsonObject.getString("xfyhzh") != null?"<![CDATA["+jsonObject.getString("xfyhzh")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"购买方地址电话\">").append("<value>");
        stringBuffer.append(jsonObject.getString("gfdzdh") != null?"<![CDATA["+jsonObject.getString("gfdzdh")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"购买方开户行及账号\">").append("<value>");
        stringBuffer.append(jsonObject.getString("gfyhzh") != null?"<![CDATA["+jsonObject.getString("gfyhzh")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"备注\">").append("<value>");
        stringBuffer.append(jsonObject.getString("bz") != null?"<![CDATA["+jsonObject.getString("bz")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"机器编号\">").append("<value>");
        stringBuffer.append(jsonObject.getString("jqbh") != null?"<![CDATA["+jsonObject.getString("jqbh")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"机打号码\">").append("<value>");
        stringBuffer.append(jsonObject.getString("jdhm") != null?"<![CDATA["+jsonObject.getString("jdhm")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"开票人\">").append("<value>");
        stringBuffer.append(jsonObject.getString("kpr") != null?"<![CDATA["+jsonObject.getString("kpr")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"收款人\">").append("<value>");
        stringBuffer.append(jsonObject.getString("skr") != null?"<![CDATA["+jsonObject.getString("skr")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"复核人\">").append("<value>");
        stringBuffer.append(jsonObject.getString("fhr") != null?"<![CDATA["+jsonObject.getString("fhr")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"合同编号\">").append("<value>");
        stringBuffer.append(jsonObject.getString("htbm") != null?"<![CDATA["+jsonObject.getString("htbm")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");

        stringBuffer.append("<column  name=\"发票文件\">").append("<value>");
        stringBuffer.append(jsonObject.getString("fpwj") != null?"<![CDATA["+jsonObject.getString("url")+"]]>":"");
        stringBuffer.append("</value>").append("</column>");


        stringBuffer.append("</values>");
        stringBuffer.append("<subForms>");
        stringBuffer.append("<subForm>");
        stringBuffer.append("<definitions>");
        stringBuffer.append("<column  id=\"field0023\" type=\"4\" name=\"序号1\" isNullable=\"false\" length=\"20\"/>");
        stringBuffer.append("<column  id=\"field0024\" type=\"0\" name=\"税收分类编码\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0025\" type=\"0\" name=\"项目名称\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0026\" type=\"0\" name=\"规格型号\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0027\" type=\"0\" name=\"单位\" isNullable=\"false\" length=\"100\"/>");
        stringBuffer.append("<column  id=\"field0028\" type=\"4\" name=\"数量\" isNullable=\"false\" length=\"20\"/>");
        stringBuffer.append("<column  id=\"field0029\" type=\"4\" name=\"单价\" isNullable=\"false\" length=\"20\"/>");
        stringBuffer.append("<column  id=\"field0030\" type=\"4\" name=\"金额\" isNullable=\"false\" length=\"20\"/>");
        stringBuffer.append("<column  id=\"field0031\" type=\"4\" name=\"税率\" isNullable=\"false\" length=\"20\"/>");
        stringBuffer.append("<column  id=\"field0032\" type=\"4\" name=\"税额\" isNullable=\"false\" length=\"20\"/>");
        stringBuffer.append("</definitions>");
        stringBuffer.append("<values>");

        JSONArray jsonArray = JSONArray.parseArray(jsonObject.getString("mdm_fp_detail"));
        if(jsonArray != null&& jsonArray.size() > 0){
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject detailObject = jsonArray.getJSONObject(i);
                stringBuffer.append("<row>");
                stringBuffer.append("<column  name=\"序号1\"><value>").append(detailObject.getString("xh") != null?"<![CDATA["+detailObject.getString("xh")+"]]>":"").append("</value></column>");
                stringBuffer.append("<column  name=\"税收分类编码\"><value>").append(detailObject.getString("ssflbm") != null?"<![CDATA["+detailObject.getString("ssflbm")+"]]>":"").append("</value></column>");
                stringBuffer.append("<column  name=\"项目名称\"><value>").append(detailObject.getString("xmmc") != null?"<![CDATA["+detailObject.getString("xmmc")+"]]>":"").append("</value></column>");
                stringBuffer.append("<column  name=\"规格型号\"><value>").append(detailObject.getString("ggxh") != null?"<![CDATA["+detailObject.getString("ggxh")+"]]>":"").append("</value></column>");
                stringBuffer.append("<column  name=\"单位\"><value>").append(detailObject.getString("dw") != null?"<![CDATA["+detailObject.getString("dw")+"]]>":"").append("</value></column>");
                stringBuffer.append("<column  name=\"数量\"><value>").append(detailObject.getString("sl") != null?"<![CDATA["+detailObject.getString("sl")+"]]>":"").append("</value></column>");
                stringBuffer.append("<column  name=\"单价\"><value>").append(detailObject.getString("dj") != null?"<![CDATA["+detailObject.getString("dj")+"]]>":"").append("</value></column>");
                stringBuffer.append("<column  name=\"金额\"><value>").append(detailObject.getString("je") != null?"<![CDATA["+detailObject.getString("je")+"]]>":"").append("</value></column>");
                stringBuffer.append("<column  name=\"税率\"><value>").append(detailObject.getString("slv") != null?"<![CDATA["+detailObject.getString("slv")+"]]>":"").append("</value></column>");
                stringBuffer.append("<column  name=\"税额\"><value>").append(detailObject.getString("se") != null?"<![CDATA["+detailObject.getString("se")+"]]>":"").append("</value></column>");
                stringBuffer.append("</row>");
            }
        }
        stringBuffer.append("</values>");
        stringBuffer.append("</subForm>");
        stringBuffer.append("</subForms>");
        stringBuffer.append("</formExport>");
        stringBuffer.append("</forms>");

        return stringBuffer.toString();
    }


    /**
     * @Author lvleigang
     * @Description 财报数据推送
     * @Date 4:28 下午 2025/4/16
     * @param requestJson
     * @return com.hzya.frame.web.entity.JsonResultEntity
     **/
    @Override
    public JsonResultEntity sendFinancialReportPlugin(JSONObject requestJson) {

        logger.error("财报数据推送入参"+requestJson.toJSONString());
        JSONObject jsonStr = requestJson.getJSONObject("jsonStr");
        JSONObject businessDataStr = jsonStr.getJSONObject("businessDataStr");
        String eventType = jsonStr.getString("eventType");
        switch (eventType) {
            case "onProcessFinished"://流程结束事件，同步物料到U8C
                JSONObject businessData = businessDataStr.getJSONObject("formmain_0708");
                if(businessData.getString("field0007") == null){//数据类型
                    return BaseResult.getFailureMessageEntity("数据类型为空");
                }
                if(businessData.getString("field0007").equals("1")){//科目余额

                }
                if(businessData.getString("field0007").equals("2")){//财报
                    return sendFinancialReport(businessData);
                }
                if(businessData.getString("field0007").equals("3")){//进项发票
                    return BaseResult.getFailureMessageEntity("数据类型错误");
                }
                if(businessData.getString("field0007").equals("4")){//销项发票
                    return BaseResult.getFailureMessageEntity("数据类型错误");
                }
                return BaseResult.getSuccessMessageEntity("推送数据成功");
            default:
                return BaseResult.getFailureMessageEntity("未匹配到流程监听事件！当前传入的eventType：" + eventType);
        }



    }

    /**
     * @Author lvleigang
     * @Description  发送财报数据
     * @Date 5:28 下午 2025/4/22
     * @param businessData
     * @return com.hzya.frame.web.entity.JsonResultEntity
     **/
    private JsonResultEntity sendFinancialReport(JSONObject businessData) {
        String access_token = getToken();
        if (access_token == null) {
            return BaseResult.getFailureMessageEntity("token获取失败");
        }
        String url = cbUrl+access_token;
        String ztbm = businessData.getString("field0005");//账套编码
        String sh = businessData.getString("field0006");//税号
        String sjlx = businessData.getString("field0007");//数据类型
        String cjzq = businessData.getString("field0008");//采集账期
        String rwbm = businessData.getString("field0009");//任务编码
        if(ztbm == null || "".equals(ztbm)){
            return BaseResult.getSuccessMessageEntity("账套编码为空");
        }
        if(cjzq == null || "".equals(cjzq)){
            return BaseResult.getSuccessMessageEntity("采集账期为空");
        }
        if(rwbm == null || "".equals(rwbm)){
            return BaseResult.getSuccessMessageEntity("任务编码为空");
        }



        Date date = null;
        String qncjzq = null;

        IncomeInvoiceEntity dyAloneId = null;
        JSONObject dydata = null;
        JSONObject qndata = null;
        IncomeInvoiceEntity qnAloneId = null;

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM");
        try {
            date = sdf.parse(cjzq);
        } catch (ParseException e) {
            return BaseResult.getSuccessMessageEntity("采集账期格式错误");
        }
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        calendar.add(Calendar.YEAR, -1);
        Date qn = calendar.getTime();
        qncjzq = sdf.format(qn);

        //查询当月帐套组织
        IncomeInvoiceEntity jnentity = new IncomeInvoiceEntity();
        jnentity.setDataSourceCode("");
        jnentity.setSysData(cjzq);
        jnentity.setOrgCode(ztbm);
        List<IncomeInvoiceEntity> jnlist = incomeInvoiceDao.queryZtzz(jnentity);
        if(jnlist != null && jnlist.size() == 1){
            dyAloneId = jnlist.get(0);
        }else {
            return BaseResult.getSuccessMessageEntity("未查询到当月的财报数据，不推送");
        }
        //查询去年当帐套组织
        IncomeInvoiceEntity qnentity = new IncomeInvoiceEntity();
        qnentity.setDataSourceCode("");
        qnentity.setSysData(qncjzq);
        qnentity.setOrgCode(ztbm);
        List<IncomeInvoiceEntity> qnlist = incomeInvoiceDao.queryZtzz(qnentity);
        if(qnlist != null && qnlist.size() == 1){
            qnAloneId = qnlist.get(0);
        }else {
            logger.info("未查询到去年当期的财报数据");
        }

        //查询当月的财报数据
        IncomeInvoiceEntity jnquerydata = new IncomeInvoiceEntity();
        jnquerydata.setDataSourceCode("");
        jnquerydata.setAloneId(dyAloneId.getAloneId());
        List<JSONObject> dydataList = incomeInvoiceDao.queryByAloneId(jnquerydata);
        if(dydataList != null && dydataList.size() == 1){
            dydata = dydataList.get(0);
        }else {
            return BaseResult.getSuccessMessageEntity("未查询到当月的财报数据，不推送");
        }
        //查询去年当期的财报数据
        if(qnAloneId != null){
            //查找去年数据
            IncomeInvoiceEntity qnquerydata = new IncomeInvoiceEntity();
            qnquerydata.setDataSourceCode("");
            qnquerydata.setAloneId(qnAloneId.getAloneId());
            List<JSONObject> qndataList = incomeInvoiceDao.queryByAloneId(qnquerydata);
            if(qndataList != null && qndataList.size() == 1){
                qndata = qndataList.get(0);
            }
        }
        //拼接数据
        JSONObject sendData = new JSONObject();
        sendData.put("accessKey",accessKey);
        long timestamp = System.currentTimeMillis();
        sendData.put("timestamp",timestamp);
        sendData.put("taskNo",rwbm);
        sendData.put("period",cjzq);

        JSONArray reportList = new JSONArray();

        JSONObject zcfzb = new JSONObject();//资产负债表
        zcfzb.put("period",cjzq);
        zcfzb.put("reportType",1);
        JSONArray reportSubjects1 = new JSONArray();
        setDataToArray("subjectName","12312",1,reportSubjects1);
        zcfzb.put("reportSubjects",reportSubjects1);

        JSONObject llb = new JSONObject();//利润表
        llb.put("period",cjzq);
        llb.put("reportType",2);
        JSONArray reportSubjects2 = new JSONArray();
        llb.put("reportSubjects",reportSubjects2);

        JSONObject xjll = new JSONObject();//现金流量表
        xjll.put("period",cjzq);
        xjll.put("reportType",3);
        JSONArray reportSubjects3 = new JSONArray();
        xjll.put("reportSubjects",reportSubjects3);





        reportList.add(zcfzb);
        reportList.add(llb);
        reportList.add(xjll);

        sendData.put("reportList",reportList);
        String a = YzfSignUtil.signRequest(sendData,accessSecret);
        sendData.put("sign",a);

        Map<String, String> headers = new HashMap<>();
        headers.put("Content-Type", "application/json; charset=utf-8");
        String returndata = sendPost(url, headers, sendData.toJSONString());

        if (returndata != null && JSONObject.isValidObject(returndata)) {
            JSONObject dataJson = JSONObject.parseObject(returndata);
            if(dataJson != null && dataJson.getString("code") != null && "0".equals( dataJson.getString("code"))){
                JSONObject data = dataJson.getJSONObject("result");
                if(data != null  ){
                    if(data != null && data.getString("resultCode") != null && "0".equals( data.getString("resultCode"))){
                        return BaseResult.getSuccessMessageEntity("执行成功");
                    }else {
                        return BaseResult.getFailureMessageEntity("发送失败："+returndata);
                    }
                }else {
                    return BaseResult.getFailureMessageEntity("发送失败："+returndata);
                }
            }else {
                return BaseResult.getFailureMessageEntity("发送失败："+returndata);
            }
        }else {
            return BaseResult.getFailureMessageEntity("发送失败："+returndata);
        }
    }

    private void setDataToArray(String subjectName, String value, Integer valueType, JSONArray reportSubjects) {
        if(value != null && !"".equals(value)){
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("subjectName",subjectName);
            jsonObject.put("value",new BigDecimal(value));
            jsonObject.put("valueType",valueType);
            reportSubjects.add(jsonObject);
        }
    }
}
